' CABisFresh.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-01-10
' CABisFresh.VBS tests whether CAB file is fresh.
' Usage: Start CABisFresh.VBS CABfile

Option Explicit
Dim fso
Dim Shell
Dim CABfile
Dim cFolder
Dim cFolderItem
Dim xFolder
Dim xFolderItem
Dim Rows
Dim FileName

If WScript.Arguments.Count<>1 Then
  WScript.Echo "No Arguments !"
  WScript.Quit
End If
CABfile=WScript.Arguments.Item(0)

Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")
CABfile=fso.GetAbsolutePathName(CABfile)
If UCase(fso.GetExtensionName(CABfile))<>"CAB" Then
  WScript.Echo "Invalid Extension Name -",fso.GetExtensionName(CABfile)
  WScript.Quit
End If
Set cFolder=Shell.NameSpace(CABfile)
Set xFolder=cFolder.ParentFolder
Rows=Array("Size	ModifyDate	Name")
For Each cFolderItem In cFolder.Items()
  FileName=fso.GetFileName(cFolderItem.Path)
  Set xFolderItem=xFolder.ParseName(FileName)
  If xFolderItem Is Nothing Then
    Push Rows,Join(Array(cFolderItem.ExtendedProperty("Size"),cFolder.GetDetailsOf(cFolderItem,3),FileName),vbTab)
  Else
    If CLng(cFolderItem.ExtendedProperty("Size"))<>xFolderItem.Size Or cFolder.GetDetailsOf(cFolderItem,3)<>xFolder.GetDetailsOf(xFolderItem,3) Then
      Push Rows,Join(Array(cFolderItem.ExtendedProperty("Size"),cFolder.GetDetailsOf(cFolderItem,3),FileName),vbTab)
      Push Rows,Join(Array(xFolderItem.Size,xFolder.GetDetailsOf(xFolderItem,3)),vbTab)
    End If
  End If
Next
If UBound(Rows) Then
  WScript.Echo Join(Rows,vbLf)
Else
  WScript.Echo fso.GetFileName(CABfile)&" is fresh."
End If
WScript.Quit

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
