' ZIPisFresh.VBS V1.02 (C) yoshioka.teruo@nifty.com 2007-06-26
' ZIPisFresh.VBS tests whether ZIP file is fresh.
' Usage: Start ZIPisFresh.VBS zipfile

Option Explicit
Dim fso
Dim Shell
Dim ZIPfile
Dim zFolder
Dim zFolderItem
Dim xFolder
Dim xFolderItem
Dim Rows

If WScript.Arguments.Count<>1 Then
  WScript.Echo "No Arguments !"
  WScript.Quit
End If
ZIPfile=WScript.Arguments.Item(0)

Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")
ZIPfile=fso.GetAbsolutePathName(ZIPfile)
If UCase(fso.GetExtensionName(ZIPfile))<>"ZIP" Then
  WScript.Echo "Invalid Extension Name -",fso.GetExtensionName(ZIPfile)
  WScript.Quit
End If
Set zFolder=Shell.NameSpace(ZIPfile)
Set xFolder=zFolder.ParentFolder
Rows=Array("Size	ModifyDate	Name")
For Each zFolderItem In zFolder.Items()
  Set xFolderItem=xFolder.ParseName(zFolderItem.Path)
  If xFolderItem Is Nothing Then
    Push Rows,Join(Array(zFolderItem.Size,zFolder.GetDetailsOf(zFolderItem,7),zFolderItem.Path),vbTab)
  Else
    If zFolderItem.Size<>xFolderItem.Size Or zFolder.GetDetailsOf(zFolderItem,7)<>xFolder.GetDetailsOf(xFolderItem,3) Then
      Push Rows,Join(Array(zFolderItem.Size,zFolder.GetDetailsOf(zFolderItem,7),zFolderItem.Path),vbTab)
      Push Rows,Join(Array(xFolderItem.Size,xFolder.GetDetailsOf(xFolderItem,3)),vbTab)
    End If
  End If
Next
If UBound(Rows) Then
  WScript.Echo Join(Rows,vbLf)
Else
  WScript.Echo fso.GetFileName(ZIPfile)&" is fresh. " & zFolder.Items().Count & " files."
End If
WScript.Quit

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
